#
# Copyright (c) 2015-2016 Wind River Systems, Inc.
#
# SPDX-License-Identifier: Apache-2.0
#


class _NfvVimRecordType(object):
    """
    NFV-VIM Record Type Constants
    """
    HOST_NFVI_STATE_CHANGE = 'nfv_vim_host_nfvi_state_change'
    HOST_CONFIGURE_STATE = 'nfv_vim_host_configure_state'
    HOST_ENABLING_STATE = 'nfv_vim_host_enabling_state'
    HOST_ENABLED_STATE = 'nfv_vim_host_enabled_state'
    HOST_DISABLING_STATE = 'nfv_vim_host_disabling_state'
    HOST_DISABLED_STATE = 'nfv_vim_host_disabled_state'
    HOST_DISABLING_FAILED_STATE = 'nfv_vim_host_disabling_failed_state'
    HOST_DELETING_STATE = 'nfv_vim_host_deleting_state'
    HOST_DELETED_STATE = 'nfv_vim_host_deleted_state'
    INSTANCE_DIRECTOR_EVACUATE_FAILED = 'nfv_vim_director_evacuate_failed'
    INSTANCE_DIRECTOR_EVACUATE_TIMEOUT = 'nfv_vim_director_evacuate_timeout'
    INSTANCE_DIRECTOR_EVACUATE_SUCCESS = 'nfv_vim_director_evacuate_success'
    INSTANCE_DIRECTOR_MIGRATE_FAILED = 'nfv_vim_director_migrate_failed'
    INSTANCE_DIRECTOR_MIGRATE_TIMEOUT = 'nfv_vim_director_migrate_timeout'
    INSTANCE_DIRECTOR_MIGRATE_SUCCESS = 'nfv_vim_director_migrate_success'
    INSTANCE_INITIAL_STATE = 'nfv_vim_instance_initial_state'
    INSTANCE_LIVE_MIGRATE_STATE = 'nfv_vim_instance_live_migrate_state'
    INSTANCE_LIVE_MIGRATE_STATE_FAILED = 'nfv_vim_instance_live_migrate_state_failed'
    INSTANCE_LIVE_MIGRATE_STATE_TIMED_OUT = 'nfv_vim_instance_live_migrate_state_timed_out'
    INSTANCE_LIVE_MIGRATE_FINISH_STATE = 'nfv_vim_instance_live_migrate_finish_state'
    INSTANCE_LIVE_MIGRATE_FINISH_STATE_FAILED = 'nfv_vim_instance_live_migrate_finish_state_failed'
    INSTANCE_LIVE_MIGRATE_FINISH_STATE_TIMED_OUT = 'nfv_vim_instance_live_migrate_finish_state_timed_out'
    INSTANCE_COLD_MIGRATE_STATE = 'nfv_vim_instance_cold_migrate_state'
    INSTANCE_COLD_MIGRATE_STATE_FAILED = 'nfv_vim_instance_cold_migrate_state_failed'
    INSTANCE_COLD_MIGRATE_STATE_TIMED_OUT = 'nfv_vim_instance_cold_migrate_state_timed_out'
    INSTANCE_COLD_MIGRATE_CONFIRM_STATE = 'nfv_vim_instance_cold_migrate_confirm_state'
    INSTANCE_COLD_MIGRATE_CONFIRM_STATE_FAILED = 'nfv_vim_instance_cold_migrate_confirm_state_failed'
    INSTANCE_COLD_MIGRATE_CONFIRM_STATE_TIMED_OUT = 'nfv_vim_instance_cold_migrate_confirm_state_timed_out'
    INSTANCE_COLD_MIGRATE_REVERT_STATE = 'nfv_vim_instance_cold_migrate_revert_state'
    INSTANCE_COLD_MIGRATE_REVERT_STATE_FAILED = 'nfv_vim_instance_cold_migrate_revert_state_failed'
    INSTANCE_COLD_MIGRATE_REVERT_STATE_TIMED_OUT = 'nfv_vim_instance_cold_migrate_revert_state_timed_out'
    INSTANCE_EVACUATE_STATE = 'nfv_vim_instance_evacuate_state'
    INSTANCE_START_STATE = 'nfv_vim_instance_start_state'
    INSTANCE_START_STATE_INPROGRESS = 'nfv_vim_instance_start_state_inprogress'
    INSTANCE_START_STATE_FAILED = 'nfv_vim_instance_start_state_failed'
    INSTANCE_START_STATE_TIMED_OUT = 'nfv_vim_instance_start_state_timed_out'
    INSTANCE_STOP_STATE = 'nfv_vim_instance_stop_state'
    INSTANCE_STOP_STATE_COMPLETED = 'nfv_vim_instance_stop_state_completed'
    INSTANCE_STOP_STATE_FAILED = 'nfv_vim_instance_stop_state_failed'
    INSTANCE_STOP_STATE_TIMED_OUT = 'nfv_vim_instance_stop_state_timed_out'
    INSTANCE_PAUSE_STATE = 'nfv_vim_instance_pause_state'
    INSTANCE_PAUSE_STATE_COMPLETED = 'nfv_vim_instance_pause_state_completed'
    INSTANCE_PAUSE_STATE_FAILED = 'nfv_vim_instance_pause_state_failed'
    INSTANCE_PAUSE_STATE_TIMED_OUT = 'nfv_vim_instance_pause_state_timed_out'
    INSTANCE_UNPAUSE_STATE = 'nfv_vim_instance_unpause_state'
    INSTANCE_UNPAUSE_STATE_COMPLETED = 'nfv_vim_instance_unpause_state_completed'
    INSTANCE_UNPAUSE_STATE_FAILED = 'nfv_vim_instance_unpause_state_failed'
    INSTANCE_UNPAUSE_STATE_TIMED_OUT = 'nfv_vim_instance_unpause_state_timed_out'
    INSTANCE_SUSPEND_STATE = 'nfv_vim_instance_suspend_state'
    INSTANCE_SUSPEND_STATE_COMPLETED = 'nfv_vim_instance_suspend_state_completed'
    INSTANCE_SUSPEND_STATE_FAILED = 'nfv_vim_instance_suspend_state_failed'
    INSTANCE_SUSPEND_STATE_TIMED_OUT = 'nfv_vim_instance_suspend_state_timed_out'
    INSTANCE_RESUME_STATE = 'nfv_vim_instance_resume_state'
    INSTANCE_RESUME_STATE_COMPLETED = 'nfv_vim_instance_resume_state_completed'
    INSTANCE_RESUME_STATE_FAILED = 'nfv_vim_instance_resume_state_failed'
    INSTANCE_RESUME_STATE_TIMED_OUT = 'nfv_vim_instance_resume_state_timed_out'
    INSTANCE_REBOOT_STATE = 'nfv_vim_instance_reboot_state'
    INSTANCE_REBOOT_STATE_COMPLETED = 'nfv_vim_instance_reboot_state_completed'
    INSTANCE_REBOOT_STATE_FAILED = 'nfv_vim_instance_reboot_state_failed'
    INSTANCE_REBOOT_STATE_TIMED_OUT = 'nfv_vim_instance_reboot_state_timed_out'
    INSTANCE_REBUILD_STATE = 'nfv_vim_instance_rebuild_state'
    INSTANCE_REBUILD_STATE_COMPLETED = 'nfv_vim_instance_rebuild_state_completed'
    INSTANCE_REBUILD_STATE_FAILED = 'nfv_vim_instance_rebuild_state_failed'
    INSTANCE_REBUILD_STATE_TIMED_OUT = 'nfv_vim_instance_rebuild_state_timed_out'
    INSTANCE_FAIL_STATE = 'nfv_vim_instance_fail_state'
    INSTANCE_DELETE_STATE = 'nfv_vim_instance_delete_state'
    INSTANCE_RESIZE_STATE = 'nfv_vim_instance_resize_state'
    INSTANCE_RESIZE_STATE_FAILED = 'nfv_vim_instance_resize_state_failed'
    INSTANCE_RESIZE_STATE_TIMED_OUT = 'nfv_vim_instance_resize_state_timed_out'
    INSTANCE_RESIZE_CONFIRM_STATE = 'nfv_vim_instance_resize_confirm_state'
    INSTANCE_RESIZE_CONFIRM_STATE_FAILED = 'nfv_vim_instance_resize_confirm_state_failed'
    INSTANCE_RESIZE_CONFIRM_STATE_TIMED_OUT = 'nfv_vim_instance_resize_confirm_state_timed_out'
    INSTANCE_RESIZE_REVERT_STATE = 'nfv_vim_instance_resize_revert_state'
    INSTANCE_RESIZE_REVERT_STATE_FAILED = 'nfv_vim_instance_resize_revert_state_failed'
    INSTANCE_RESIZE_REVERT_STATE_TIMED_OUT = 'nfv_vim_instance_resize_revert_state_timed_out'
    INSTANCE_GUEST_SERVICES_CREATE_STATE = 'nfv_vim_instance_guest_services_create_state'
    INSTANCE_GUEST_SERVICES_DELETE_STATE = 'nfv_vim_instance_guest_services_delete_state'
    INSTANCE_GUEST_SERVICES_ENABLE_STATE = 'nfv_vim_instance_guest_services_enable_state'
    INSTANCE_GUEST_SERVICES_DISABLE_STATE = 'nfv_vim_instance_guest_services_disable_state'
    INSTANCE_GUEST_SERVICES_SET_STATE = 'nfv_vim_instance_guest_services_set_state'
    INSTANCE_NFVI_ACTION_START = 'nfv_vim_instance_nfvi_action_initial'
    INSTANCE_NFVI_STATE_CHANGE = 'nfv_vim_instance_nfvi_state_change'
    INSTANCE_START_CALLBACK = 'nfv_vim_instance_start_callback'
    INSTANCE_STOP_CALLBACK = 'nfv_vim_instance_stop_callback'
    INSTANCE_PAUSE_CALLBACK = 'nfv_vim_instance_pause_callback'
    INSTANCE_UNPAUSE_CALLBACK = 'nfv_vim_instance_unpause_callback'
    INSTANCE_SUSPEND_CALLBACK = 'nfv_vim_instance_suspend_callback'
    INSTANCE_RESUME_CALLBACK = 'nfv_vim_instance_resume_callback'
    INSTANCE_REBOOT_CALLBACK = 'nfv_vim_instance_reboot_callback'
    INSTANCE_REBUILD_CALLBACK = 'nfv_vim_instance_rebuild_callback'
    INSTANCE_LIVE_MIGRATE_CALLBACK = 'nfv_vim_instance_live_migrate_callback'
    INSTANCE_COLD_MIGRATE_CALLBACK = 'nfv_vim_instance_cold_migrate_callback'
    INSTANCE_COLD_MIGRATE_CONFIRM_CALLBACK = 'nfv_vim_instance_cold_migrate_confirm_callback'
    INSTANCE_COLD_MIGRATE_REVERT_CALLBACK = 'nfv_vim_instance_cold_migrate_revert_callback'
    INSTANCE_RESIZE_CALLBACK = 'nfv_vim_instance_resize_callback'
    INSTANCE_RESIZE_CONFIRM_CALLBACK = 'nfv_vim_instance_resize_confirm_callback'
    INSTANCE_RESIZE_REVERT_CALLBACK = 'nfv_vim_instance_resize_revert_callback'
    INSTANCE_GUEST_SERVICES_NOTIFY = 'nfv_vim_instance_guest_services_notify'
    INSTANCE_GUEST_SERVICES_ENABLE = 'nfv_vim_instance_guest_services_enable'
    INSTANCE_GUEST_SERVICES_ENABLE_CALLBACK = 'nfv_vim_instance_guest_services_enable_callback'
    INSTANCE_GUEST_SERVICES_DISABLE = 'nfv_vim_instance_guest_services_disable'
    INSTANCE_GUEST_SERVICES_DISABLE_CALLBACK = 'nfv_vim_instance_guest_services_disable_callback'
    INSTANCE_GUEST_SERVICES_VOTE = 'nfv_vim_instance_guest_services_vote'
    INSTANCE_GUEST_SERVICES_VOTE_RESULT = 'nfv_vim_instance_guest_services_vote_result'
    INSTANCE_GUEST_SERVICES_VOTE_CALLBACK = 'nfv_vim_instance_guest_services_vote_callback'
    INSTANCE_GUEST_SERVICES_PRE_NOTIFY = 'nfv_vim_instance_guest_services_pre_notify'
    INSTANCE_GUEST_SERVICES_PRE_NOTIFY_CALLBACK = 'nfv_vim_instance_guest_services_pre_notify_callback'
    INSTANCE_GUEST_SERVICES_POST_NOTIFY = 'nfv_vim_instance_guest_services_post_notify'
    INSTANCE_GUEST_SERVICES_POST_NOTIFY_CALLBACK = 'nfv_vim_instance_guest_services_post_notify_callback'
    INSTANCE_GUEST_SERVICES_POST_NOTIFY_HEARTBEAT = 'nfv_vim_instance_guest_services_post_notify_heartbeat'


# Constant Instantiation
NFV_VIM = _NfvVimRecordType()
